Bug 20433 - Отсутствует init скрипт для timidity
: Отсутствует init скрипт для timidity
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/TiMidity++)
: unstable
: all Linux
: P3 enhancement
Assigned To:
:
:
:
:
: 17728 19564
  Show dependency tree
 
Reported: 2009-06-13 14:14 by
Modified: 2009-09-02 22:19 (History)


Attachments
initial initscript sketch (1.61 KB, text/plain)
2009-07-20 18:29, Michael Shigorin
no flags Details
updated initscript sketch (1.65 KB, text/plain)
2009-08-16 18:16, Michael Shigorin
no flags Details
initial sysconfig file (87 bytes, text/plain)
2009-08-16 18:16, Michael Shigorin
no flags Details
fixed initscript (1.65 KB, text/plain)
2009-09-01 21:38, Michael Shigorin
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2009-06-13 14:14:22
Нынче мало звуковых плат с аппаратной поддержкой MIDI, потому необходимо делать
программный синтез. Предлагать запускать вручную "timidity -iAD" каждый раз,
когда есть необходимость в проигрывании MIDI-файла не user-friendly подход.

Для примера см. http://www.gentoo.org/doc/ru/alsa-guide.xml#doc_chap4_sect2
------- Comment #1 From 2009-06-14 00:53:43 -------
s/major/enhancement/ -- см. http://www.altlinux.org/BugSeverityPolicy и
поскольку это не единственный режим использования софтинки.  Мало того, ещё и
режим, совсем не используемый мной как майнтейнером :-)

Александр, не хотите глянуть /etc/init.d/template и нарисовать инитскрипт,
который бы Вас лично устроил?  В пакет проверенный добавить удобнее, чем
узнавать новое о пакете, которым сам давно особо не пользуешься.

Если же интереса и здоровья хватает -- то можете попробовать и весь пакет взять
под свою опёку, в timidity-talk@ и посейчас то патчики какие-то пролетают, то
ссылки на patch set'ы.
------- Comment #2 From 2009-07-20 18:29:30 -------
Created an attachment (id=3678) [details]
initial initscript sketch

Александр, можете глянуть приложенный набросок -- устроит такой?  Он имеет как
минимум тот недостаток, что запуск производится от root, при интеграции в пакет
надо будет ещё псевдопользователя стряпать, но хоть работает или нет.

2 ldv: а как бы просунуть некоторые полезные, но не поддерживаемые у нас в
/etc/rc.d/init.d/functions::start_daemon() параметры из вот такого
Gentoo/portage/media-sound/timidity++/files/init.d.timidity.3?  Или достаточно
--user, а --chdir всё равно косметический?

        start-stop-daemon --start --background --chdir /usr/share/timidity \
        --chuid timidity:audio --make-pidfile --pidfile /var/run/timidity.pid \
        --exec /usr/bin/timidity -- -iA ${TIMIDITY_OPTS}
------- Comment #3 From 2009-07-20 23:31:15 -------
(В ответ на комментарий №2)
> Александр, можете глянуть приложенный набросок -- устроит такой?  Он имеет как
> минимум тот недостаток, что запуск производится от root, при интеграции в пакет
> надо будет ещё псевдопользователя стряпать, но хоть работает или нет.
Меня всё устроит, лишь бы работало. Я посмотрел, что на форуме учителя
спрашивают про MIDI, но что в рассылках, что там до оргвыводов доходит нечасто
:)

К этому скрипту ещё параметры в /etc/conf.d/timidity лежат
"TIMIDITY_OPTS="-B2,8 -Os -EFreverb=0" (в альте такое наверно в /etc/sysconfig
кладут).

Вообще вместо него "ведущие собаководы" рекомендуют FluidSynth (меньше
латентность).
------- Comment #4 From 2009-08-16 18:03:35 -------
(В ответ на комментарий №3)

> 
> Вообще вместо него "ведущие собаководы" рекомендуют FluidSynth (меньше
> латентность).

У нас и этот в хозяйстве есть
------- Comment #5 From 2009-08-16 18:05:43 -------
См. обсуждение учителей: http://forum.altlinux.org/index.php/topic,176.0.html
Вешаю на #19564
------- Comment #6 From 2009-08-16 18:16:04 -------
Created an attachment (id=3741) [details]
updated initscript sketch

(In reply to comment #3)
> > Александр, можете глянуть приложенный набросок -- устроит такой?
> Меня всё устроит, лишь бы работало.
А можете всё-таки глянуть и сказать -- да или нет?

> Я посмотрел, что на форуме учителя  спрашивают про MIDI, но что в рассылках,
> что там до оргвыводов доходит нечасто :)
Есть такая беда, но лучше всего, когда заинтересованность в пакете личная, а
этот я уже много лет сопровождаю по старой памяти, а не как пользователь.

Может, возьмётесь за него?  Чем смогу -- помогу, в т.ч. общением с апстримом
при необходимости.

> К этому скрипту ещё параметры в /etc/conf.d/timidity лежат
> "TIMIDITY_OPTS="-B2,8 -Os -EFreverb=0" (в альте такое наверно в /etc/sysconfig
> кладут).
Да, проморгал -- поправил инитскрипт, проверите?

(In reply to comment #5)
> См. обсуждение учителей: http://forum.altlinux.org/index.php/topic,176.0.html
> Вешаю на #19564
Хорошо бы это помогло тестированию приложенного или появлению майнтейнера.
Могу добавить @everyone в ACL.
------- Comment #7 From 2009-08-16 18:16:32 -------
Created an attachment (id=3742) [details]
initial sysconfig file
------- Comment #8 From 2009-08-16 18:34:06 -------
для чего нужен timidity? точнее откуда планируется воспроизводить midi файлы?
если из стандартных произрывателей, то xine/gstreamer midi играют без всяких
костылей
------- Comment #9 From 2009-08-16 18:39:02 -------
(В ответ на комментарий №8)
> для чего нужен timidity? точнее откуда планируется воспроизводить midi файлы?
> если из стандартных произрывателей, то xine/gstreamer midi играют без всяких
> костылей
Надо посмотреть, какие штатные проигрыватели в Gnome и KDE. Жалобы на форуме
были на неработающий kmidi, что естественно.
Вопрос к zerg и aris.
------- Comment #10 From 2009-08-16 18:40:35 -------
(В ответ на комментарий №9)
> (В ответ на комментарий №8)
> > для чего нужен timidity? точнее откуда планируется воспроизводить midi файлы?
> > если из стандартных произрывателей, то xine/gstreamer midi играют без всяких
> > костылей
> Надо посмотреть, какие штатные проигрыватели в Gnome и KDE. Жалобы на форуме
> были на неработающий kmidi, что естественно.
> Вопрос к zerg и aris.
И в xfce, 2dkoryavov
------- Comment #11 From 2009-08-16 19:04:32 -------
(In reply to comment #9)
> (В ответ на комментарий №8)
> > для чего нужен timidity? точнее откуда планируется воспроизводить midi файлы?
> > если из стандартных произрывателей, то xine/gstreamer midi играют без всяких
> > костылей
> Надо посмотреть, какие штатные проигрыватели в Gnome и KDE. Жалобы на форуме
> были на неработающий kmidi, что естественно.
> Вопрос к zerg и aris.

rhythmbox играет midi.
------- Comment #12 From 2009-08-16 22:31:24 -------
BTW:
< TiMidity++ add @everybody
> OK: TiMidity++: mike damir stanv @everybody
Summary: acl change transaction COMPLETE.
------- Comment #13 From 2009-09-01 18:41:18 -------
(В ответ на комментарий №6)
> А можете всё-таки глянуть и сказать -- да или нет?
Нет, такой не подходит. Это легко проверить, что не уходит в фон и init скрипт
не завершается.
------- Comment #14 From 2009-09-01 21:38:26 -------
Created an attachment (id=3818) [details]
fixed initscript

(посмотрев в ман) Да, и впрямь нужно -iAD вместо -iA.  Проверьте ещё
приложенный инитскрипт, а я пока с ним пакет соберу.
------- Comment #15 From 2009-09-01 22:07:57 -------
(В ответ на комментарий №14)
> Created an attachment (id=3818) [details] [details]
> fixed initscript
> 
> (посмотрев в ман) Да, и впрямь нужно -iAD вместо -iA.  Проверьте ещё
> приложенный инитскрипт, а я пока с ним пакет соберу.
Так работает.
Неплохо бы учесть comment #2 по поводу рута.
------- Comment #16 From 2009-09-02 21:53:38 -------
TiMidity++-2.13.2-alt10 -> sisyphus:

* Wed Sep 02 2009 Michael Shigorin <mike@altlinux> 2.13.2-alt10

- introduced initscript (closes: #20433)
- replaced debian menufile with freedesktop one
- /etc/timidity.cfg is now non-autoreplaceable config
------- Comment #17 From 2009-09-02 22:19:23 -------
(In reply to comment #15)
> Неплохо бы учесть comment #2 по поводу рута.
Неплохо бы, но тут ещё попадаем на права доступа к /dev/snd/seq (ой, забыл ещё
добавить в инитскрипт проверку/загрузку snd-seq.ko).  Со всеми этими
современными уро^W^W ConsoleKit я даже не соображу, как бы это оформить. :-(